<svelte:options tag="audio-recorder"/>

<div class="container">
    <button on:click={handleRecord} disabled={recording} class:active={recording}><span>&#9673;</span></button>
    <button on:click={handleStop} disabled={!recording}><span>&#9724;</span></button>
    <audio src={audioUrl} controls></audio>
</div>

<script>
    import {onMount} from 'svelte';
    import {get_current_component} from "svelte/internal";

    const thisComponent = get_current_component();

    let started = false;
    let recording = false;
    let mediaRecorder;
    let audioUrl = "";

    onMount(() => {
        if (!navigator.mediaDevices)
            return;

        navigator.mediaDevices.getUserMedia({audio: true, video: false}).then(handleSuccess);
    });


    const handleRecord = () => {
        if (!started || recording)
            return;


        mediaRecorder.start();
        recording = true;
    }


    const handleStop = () => {
        if (!started || !recording)
            return;


        mediaRecorder.stop();
        recording = false;
    }

    const handleSuccess = function (stream) {
        const chunks = [];
        mediaRecorder = new MediaRecorder(stream);

        mediaRecorder.onstop = function (e) {
            const blob = new Blob(chunks, {'type': 'audio/ogg; codecs=opus'});
            chunks.length = 0;
            audioUrl = window.URL.createObjectURL(blob);

            const reader = new FileReader();
            reader.readAsDataURL(blob);
            reader.onloadend = function () {
                const base64data = reader.result;
                thisComponent.dispatchEvent(new CustomEvent('change', {
                    detail: base64data,
                    composed: true, // propagate across the shadow DOM
                }));
            }
        }

        mediaRecorder.ondataavailable = function (e) {
            chunks.push(e.data);
        }
        started = true;
    };


</script>
<style>
    button {
        background-color: #f1f3f4;
        border-radius: 50%;
        border: none;
        width: 40px;
        height: 40px;
        font-size: 20px;
        margin-right: 10px;
        cursor: pointer;
    }

    button:hover {
        background-color: #ccc;
    }

    button[disabled] {
        background-color: #f1f3f4;
        cursor: auto;
    }

    .container {
        display: flex;
        justify-content: center;
        align-items: center;
    }

    .active {
        background-color: #cc0000 !important;
        color: #fff;
    }
</style>
